"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.ExpandButton = exports.EditorLayout = void 0;
const React = __importStar(require("react"));
const design_system_1 = require("@strapi/design-system");
const helper_plugin_1 = require("@strapi/helper-plugin");
const icons_1 = require("@strapi/icons");
const react_intl_1 = require("react-intl");
const styled_components_1 = __importDefault(require("styled-components"));
const PreviewWysiwyg_1 = require("./PreviewWysiwyg");
const EditorLayout = ({ children, isExpandMode, error, previewContent = '', onCollapse, }) => {
    const { formatMessage } = (0, react_intl_1.useIntl)();
    (0, helper_plugin_1.useLockScroll)({ lockScroll: isExpandMode });
    if (isExpandMode) {
        return (React.createElement(design_system_1.Portal, { role: "dialog", "aria-modal": false },
            React.createElement(design_system_1.FocusTrap, { onEscape: onCollapse },
                React.createElement(ExpandWrapper, { position: "fixed", top: 0, left: 0, right: 0, bottom: 0, zIndex: 4, justifyContent: "center", onClick: onCollapse },
                    React.createElement(design_system_1.Box, { background: "neutral0", hasRadius: true, shadow: "popupShadow", overflow: "hidden", width: "90%", height: "90%", onClick: (e) => e.stopPropagation() },
                        React.createElement(design_system_1.Flex, { height: "100%", alignItems: "flex-start" },
                            React.createElement(BoxWithBorder, { flex: "1", height: "100%" }, children),
                            React.createElement(design_system_1.Flex, { alignItems: "start", direction: "column", flex: 1, height: "100%", width: "100%" },
                                React.createElement(design_system_1.Flex, { height: (0, helper_plugin_1.pxToRem)(48), background: "neutral100", justifyContent: "flex-end", shrink: 0, width: "100%" },
                                    React.createElement(ExpandButton, { onClick: onCollapse },
                                        React.createElement(design_system_1.Typography, null, formatMessage({
                                            id: 'components.Wysiwyg.collapse',
                                            defaultMessage: 'Collapse',
                                        })),
                                        React.createElement(icons_1.Collapse, null))),
                                React.createElement(design_system_1.Box, { position: "relative", height: "100%", width: "100%" },
                                    React.createElement(PreviewWysiwyg_1.PreviewWysiwyg, { data: previewContent })))))))));
    }
    return (React.createElement(design_system_1.Box, { borderColor: error ? 'danger600' : 'neutral200', borderStyle: "solid", borderWidth: "1px", hasRadius: true }, children));
};
exports.EditorLayout = EditorLayout;
const ExpandWrapper = (0, styled_components_1.default)(design_system_1.Flex) `
  background: ${({ theme }) => `${theme.colors.neutral800}${Math.floor(0.2 * 255)
    .toString(16)
    .padStart(2, '0')}`};
`;
const BoxWithBorder = (0, styled_components_1.default)(design_system_1.Box) `
  border-right: 1px solid ${({ theme }) => theme.colors.neutral200};
`;
const ExpandButton = (0, styled_components_1.default)(design_system_1.BaseButton) `
  background-color: transparent;
  border: none;
  align-items: center;

  svg {
    margin-left: ${({ theme }) => `${theme.spaces[2]}`};

    path {
      fill: ${({ theme }) => theme.colors.neutral700};
      width: ${12 / 16}rem;
      height: ${12 / 16}rem;
    }
  }
`;
exports.ExpandButton = ExpandButton;
//# sourceMappingURL=EditorLayout.js.map