"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.WysiwygNav = void 0;
const React = __importStar(require("react"));
const design_system_1 = require("@strapi/design-system");
const icons_1 = require("@strapi/icons");
const react_intl_1 = require("react-intl");
const styled_components_1 = __importDefault(require("styled-components"));
const WysiwygStyles_1 = require("./WysiwygStyles");
const WysiwygNav = ({ disabled, editorRef, isExpandMode, isPreviewMode, onActionClick, onToggleMediaLib, onTogglePreviewMode, }) => {
    const [visiblePopover, setVisiblePopover] = React.useState(false);
    const { formatMessage } = (0, react_intl_1.useIntl)();
    const selectPlaceholder = formatMessage({
        id: 'components.Wysiwyg.selectOptions.title',
        defaultMessage: 'Add a title',
    });
    const buttonMoreRef = React.useRef(null);
    const handleTogglePopover = () => {
        setVisiblePopover((prev) => !prev);
    };
    if (disabled || isPreviewMode) {
        return (React.createElement(design_system_1.Flex, { padding: 2, background: "neutral100", justifyContent: "space-between", borderRadius: `${4 / 16}rem ${4 / 16}rem 0 0` },
            React.createElement(StyledFlex, null,
                React.createElement(design_system_1.SingleSelect, { disabled: true, placeholder: selectPlaceholder, size: "S", label: selectPlaceholder },
                    React.createElement(design_system_1.SingleSelectOption, { value: "h1" }, "h1"),
                    React.createElement(design_system_1.SingleSelectOption, { value: "h2" }, "h2"),
                    React.createElement(design_system_1.SingleSelectOption, { value: "h3" }, "h3"),
                    React.createElement(design_system_1.SingleSelectOption, { value: "h4" }, "h4"),
                    React.createElement(design_system_1.SingleSelectOption, { value: "h5" }, "h5"),
                    React.createElement(design_system_1.SingleSelectOption, { value: "h6" }, "h6")),
                React.createElement(WysiwygStyles_1.MainButtons, null,
                    React.createElement(WysiwygStyles_1.CustomIconButton, { disabled: true, label: "Bold", name: "Bold", icon: React.createElement(icons_1.Bold, null) }),
                    React.createElement(WysiwygStyles_1.CustomIconButton, { disabled: true, label: "Italic", name: "Italic", icon: React.createElement(icons_1.Italic, null) }),
                    React.createElement(WysiwygStyles_1.CustomIconButton, { disabled: true, label: "Underline", name: "Underline", icon: React.createElement(icons_1.Underline, null) })),
                React.createElement(WysiwygStyles_1.MoreButton, { disabled: true, label: "More", icon: React.createElement(icons_1.More, null) })),
            !isExpandMode && (React.createElement(design_system_1.Button, { onClick: onTogglePreviewMode, variant: "tertiary" }, formatMessage({
                id: 'components.Wysiwyg.ToggleMode.markdown-mode',
                defaultMessage: 'Markdown mode',
            })))));
    }
    return (React.createElement(design_system_1.Flex, { padding: 2, background: "neutral100", justifyContent: "space-between", borderRadius: `${4 / 16}rem ${4 / 16}rem 0 0` },
        React.createElement(StyledFlex, null,
            React.createElement(design_system_1.SingleSelect, { placeholder: selectPlaceholder, label: selectPlaceholder, size: "S", onChange: (value) => onActionClick(value, editorRef) },
                React.createElement(design_system_1.SingleSelectOption, { value: "h1" }, "h1"),
                React.createElement(design_system_1.SingleSelectOption, { value: "h2" }, "h2"),
                React.createElement(design_system_1.SingleSelectOption, { value: "h3" }, "h3"),
                React.createElement(design_system_1.SingleSelectOption, { value: "h4" }, "h4"),
                React.createElement(design_system_1.SingleSelectOption, { value: "h5" }, "h5"),
                React.createElement(design_system_1.SingleSelectOption, { value: "h6" }, "h6")),
            React.createElement(WysiwygStyles_1.MainButtons, null,
                React.createElement(WysiwygStyles_1.CustomIconButton, { onClick: () => onActionClick('Bold', editorRef), label: "Bold", name: "Bold", icon: React.createElement(icons_1.Bold, null) }),
                React.createElement(WysiwygStyles_1.CustomIconButton, { onClick: () => onActionClick('Italic', editorRef), label: "Italic", name: "Italic", icon: React.createElement(icons_1.Italic, null) }),
                React.createElement(WysiwygStyles_1.CustomIconButton, { onClick: () => onActionClick('Underline', editorRef), label: "Underline", name: "Underline", icon: React.createElement(icons_1.Underline, null) })),
            React.createElement(WysiwygStyles_1.MoreButton, { ref: buttonMoreRef, onClick: handleTogglePopover, label: "More", icon: React.createElement(icons_1.More, null) }),
            visiblePopover && (React.createElement(design_system_1.Popover, { onDismiss: handleTogglePopover, centered: true, source: buttonMoreRef, spacing: 4 },
                React.createElement(design_system_1.Flex, null,
                    React.createElement(WysiwygStyles_1.IconButtonGroupMargin, null,
                        React.createElement(WysiwygStyles_1.CustomIconButton, { onClick: () => onActionClick('Strikethrough', editorRef, handleTogglePopover), label: "Strikethrough", name: "Strikethrough", icon: React.createElement(icons_1.StrikeThrough, null) }),
                        React.createElement(WysiwygStyles_1.CustomIconButton, { onClick: () => onActionClick('BulletList', editorRef, handleTogglePopover), label: "BulletList", name: "BulletList", icon: React.createElement(icons_1.BulletList, null) }),
                        React.createElement(WysiwygStyles_1.CustomIconButton, { onClick: () => onActionClick('NumberList', editorRef, handleTogglePopover), label: "NumberList", name: "NumberList", icon: React.createElement(icons_1.NumberList, null) })),
                    React.createElement(design_system_1.IconButtonGroup, null,
                        React.createElement(WysiwygStyles_1.CustomIconButton, { onClick: () => onActionClick('Code', editorRef, handleTogglePopover), label: "Code", name: "Code", icon: React.createElement(icons_1.Code, null) }),
                        React.createElement(WysiwygStyles_1.CustomIconButton, { onClick: () => {
                                handleTogglePopover();
                                onToggleMediaLib();
                            }, label: "Image", name: "Image", icon: React.createElement(icons_1.Picture, null) }),
                        React.createElement(WysiwygStyles_1.CustomLinkIconButton, { onClick: () => onActionClick('Link', editorRef, handleTogglePopover), label: "Link", name: "Link", icon: React.createElement(icons_1.Link, null) }),
                        React.createElement(WysiwygStyles_1.CustomIconButton, { onClick: () => onActionClick('Quote', editorRef, handleTogglePopover), label: "Quote", name: "Quote", icon: React.createElement(icons_1.Quote, null) })))))),
        onTogglePreviewMode && (React.createElement(design_system_1.Button, { onClick: onTogglePreviewMode, variant: "tertiary" }, formatMessage({
            id: 'components.Wysiwyg.ToggleMode.preview-mode',
            defaultMessage: 'Preview mode',
        })))));
};
exports.WysiwygNav = WysiwygNav;
const StyledFlex = (0, styled_components_1.default)(design_system_1.Flex) `
  /* Hide the label, every input needs a label. */
  label {
    border: 0;
    clip: rect(0 0 0 0);
    height: 1px;
    margin: -1px;
    overflow: hidden;
    padding: 0;
    position: absolute;
    width: 1px;
  }
`;
//# sourceMappingURL=WysiwygNav.js.map